
#property indicator_chart_window
#property indicator_buffers 10
#property indicator_color10 clrGold
#property indicator_color9  clrGold
#property indicator_color8  clrSandyBrown
#property indicator_color7  clrSandyBrown
#property indicator_color6  clrOrangeRed
#property indicator_color5  clrOrangeRed
#property indicator_color4  clrDeepPink
#property indicator_color3  clrDeepPink
#property indicator_color2  clrFireBrick
#property indicator_color1  clrFireBrick
//---- buffers
double buf_up1[];
double buf_down1[];

double buf_up2[];
double buf_down2[];

double buf_up3[];
double buf_down3[];

double buf_up4[];
double buf_down4[];

double buf_up5[];
double buf_down5[];

extern int Period_1 = PERIOD_MN1;
extern int Period_2 = PERIOD_W1;
extern int Period_3 = PERIOD_D1;
extern int Period_4 = PERIOD_H4;
extern int Period_5 = PERIOD_H1;


extern bool display_Period_1 = true;
extern bool display_Period_2 = true;
extern bool display_Period_3 = true;
extern bool display_Period_4 = true;
extern bool display_Period_5 = true;

extern bool Play_Sound = true;



//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
  int nSym5=158, nSym4=115, nSym3=119, nSym2=116, nSym1=117;
//---- indicators
   int draw = DRAW_ARROW; if (!display_Period_5 || Period_5<Period()) draw = DRAW_NONE;
   SetIndexStyle(8,draw); 
   SetIndexArrow(8,nSym5); //169
   SetIndexStyle(9,draw);
   SetIndexArrow(9,nSym5);
   
   SetIndexBuffer(8,buf_up5);
   SetIndexBuffer(9,buf_down5);
   
   draw = DRAW_ARROW; if (!display_Period_4 || Period_4<Period()) draw = DRAW_NONE;
   SetIndexStyle(6,draw);
   SetIndexArrow(6,nSym4);
   SetIndexStyle(7,draw);
   SetIndexArrow(7,nSym4);
   
   SetIndexBuffer(6,buf_up4);
   SetIndexBuffer(7,buf_down4);
   
   draw = DRAW_ARROW; if (!display_Period_3 || Period_3<Period()) draw = DRAW_NONE;
   SetIndexStyle(4,draw);
   SetIndexArrow(4,nSym3); //170
   SetIndexStyle(5,draw);
   SetIndexArrow(5,nSym3);

   SetIndexBuffer(4,buf_up3);
   SetIndexBuffer(5,buf_down3);


   draw = DRAW_ARROW; if (!display_Period_2 || Period_2<Period()) draw = DRAW_NONE;
   SetIndexStyle(2,draw);
   SetIndexArrow(2,nSym2); //171
   SetIndexStyle(3,draw);
   SetIndexArrow(3,nSym2);

   SetIndexBuffer(2,buf_up2);
   SetIndexBuffer(3,buf_down2);

   draw = DRAW_ARROW; if (!display_Period_1 || Period_1<Period()) draw = DRAW_NONE;
   SetIndexStyle(0,draw);
   SetIndexArrow(0,nSym1); //172
   SetIndexStyle(1,draw);
   SetIndexArrow(1,nSym1);

   SetIndexBuffer(0,buf_up1);
   SetIndexBuffer(1,buf_down1);

   if (Period_1<Period())Period_1=Period();
   if (Period_2<Period())Period_2=Period();
   if (Period_3<Period())Period_3=Period();
   if (Period_4<Period())Period_4=Period();
   if (Period_5<Period())Period_5=Period();

   SetIndexLabel(0, tf2txt(Period_1)); SetIndexLabel(1, tf2txt(Period_1));
   SetIndexLabel(2, tf2txt(Period_2)); SetIndexLabel(3, tf2txt(Period_2));
   SetIndexLabel(4, tf2txt(Period_3)); SetIndexLabel(5, tf2txt(Period_3));
   SetIndexLabel(6, tf2txt(Period_4)); SetIndexLabel(7, tf2txt(Period_4));
   SetIndexLabel(8, tf2txt(Period_5)); SetIndexLabel(9, tf2txt(Period_5));


//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    counted_bars=IndicatorCounted();
   int i=0, y1=0, y2=0, y3=0, y4=0, y5=0;
   int limit=Bars-counted_bars +Period_1/Period();

   double pd_1=0, pd_2=0, pd_3=0, pd_4=0, pd_5=0;
   double pu_1=0, pu_2=0, pu_3=0, pu_4=0, pu_5=0;
   
   datetime TimeArray_5[] ,TimeArray_4[], TimeArray_3[], TimeArray_2[], TimeArray_1[];
//----
   ArrayCopySeries(TimeArray_5,MODE_TIME,Symbol(),Period_5);
   ArrayCopySeries(TimeArray_4,MODE_TIME,Symbol(),Period_4); 
   ArrayCopySeries(TimeArray_3,MODE_TIME,Symbol(),Period_3); 
   ArrayCopySeries(TimeArray_2,MODE_TIME,Symbol(),Period_2); 
   ArrayCopySeries(TimeArray_1,MODE_TIME,Symbol(),Period_1);
      
   for(i=0, y1=0,  y2=0,  y3=0,  y4=0, y5=0;i<limit;i++)
   {
      if (Time[i]<TimeArray_1[y1]) y1++;
      if (Time[i]<TimeArray_2[y2]) y2++;
      if (Time[i]<TimeArray_3[y3]) y3++;
      if (Time[i]<TimeArray_4[y4]) y4++;
      if (Time[i]<TimeArray_5[y5]) y5++;      
      
      buf_up5[i]    = iFractals( NULL, Period_5, MODE_HIGH, y5); 
      buf_down5[i]  = iFractals( NULL, Period_5, MODE_LOW, y5);
            
      buf_up4[i]    = iFractals( NULL, Period_4, MODE_HIGH, y4); 
      buf_down4[i]  = iFractals( NULL, Period_4, MODE_LOW, y4);
      
      buf_up3[i]    = iFractals ( NULL, Period_3, MODE_HIGH, y3); 
      buf_down3[i]  = iFractals( NULL, Period_3, MODE_LOW, y3);

      
      buf_up2[i]    = iFractals( NULL, Period_2, MODE_HIGH, y2);
      buf_down2[i]  = iFractals( NULL, Period_2, MODE_LOW, y2);
      
      
      buf_up1[i]   = iFractals( NULL, Period_1, MODE_HIGH, y1);
      buf_down1[i] = iFractals( NULL, Period_1, MODE_LOW, y1);

   }
   
   for (i=limit; i>=0; i--)
   {
      if (   buf_up5[i] == 0 )   buf_up5[i] = pu_5; else  pu_5 = buf_up5[i];
      if (   buf_down5[i] == 0 ) buf_down5[i] = pd_5; else  pd_5 = buf_down5[i];
      
      if (   buf_up4[i] == 0 )   buf_up4[i] = pu_4; else  pu_4 = buf_up4[i];
      if (   buf_down4[i] == 0 ) buf_down4[i] = pd_4; else  pd_4 = buf_down4[i];
      
      if (   buf_up3[i] == 0 )   buf_up3[i] = pu_3; else  pu_3 = buf_up3[i];
      if (   buf_down3[i] == 0 ) buf_down3[i] = pd_3; else  pd_3 = buf_down3[i];
      
      if (   buf_up2[i] == 0 )   buf_up2[i] = pu_2; else  pu_2 = buf_up2[i];
      if (   buf_down2[i] == 0 ) buf_down2[i] = pd_2; else  pd_2 = buf_down2[i];
      
      if (   buf_up1[i] == 0 )   buf_up1[i] = pu_1; else  pu_1 = buf_up1[i];
      if (   buf_down1[i] == 0 ) buf_down1[i] = pd_1; else  pd_1 = buf_down1[i];
   }

//----
   return(0);
  }
//+------------------------------------------------------------------+


string tf2txt(int tf)
{
   if (tf == PERIOD_M1)    return("M1");
   if (tf == PERIOD_M5)    return("M5");
   if (tf == PERIOD_M15)    return("M15");
   if (tf == PERIOD_M30)    return("M30");
   if (tf == PERIOD_H1)    return("H1");
   if (tf == PERIOD_H4)    return("H4");
   if (tf == PERIOD_D1)    return("D1");
   if (tf == PERIOD_W1)    return("W1");
   if (tf == PERIOD_MN1)    return("MN1");
   
   return("??");
}

